;**************************************************************************
;* FileName	: MENU.INC
;* Date 	: 26.10.2002
;* File version : v1.03
;*
;* Author	: MIKO, Imre
;* Company	:
;* Homepage	: http://majki.fw.hu
;* E-mail	: majki@fw.hu
;*
;*-------------------------------------------------------------------------
;*
;* Description	: Menu for CID
;*		  ==================================
;*		  MENU
;*		  MENU_print_bcd
;*		  MENU_print
;*		  MENU_down
;*		  MENU_up
;*		  MENU_print_callno
;*		  MENU_wait
;*
;*-------------------------------------------------------------------------
;* Needed defines in main-modul:
;* 
;* #define		MENU_IDLE	<idle label>
;*
;*-------------------------------------------------------------------------
;* Other possible defines in main-modul:
;*
;*   <none>
;*
;**************************************************************************
;* Revision History:
;*
;* 1.00	  03/06/2001 	Initial Release
;* 1.01   23/08/2001    - new function: MENU_wait
;*                      - correction of deletion of call list
;*			- change numbering order
;* 1.02	  15/06/2002    - print number of missed call
;*			- print call duration during incomming call
;*			- fix wrong list handling after delete
;* 1.03	  26/10/2002	- replace obsolete bcd module with math module
;*			- start only with OK button
;*
;**************************************************************************

;***** VARIABLES **********************************************************

	cblock
		MENU_temp
		MENU_pos
		MENU_event
		MENU_loop
		MENU_tlow
		MENU_thigh
		MENU_templen
		MENU_listitem
		MENU_listlen
		MENU_delay
	endc



;--------------------------------------------------------------------------


;**************************************************************************
;***** menu call **********************************************************
;**************************************************************************
ML_call_idle	call	MENU_IDLE
		movwf	MENU_event

		movlw	MEVENT_NEWCALL
		xorwf	MENU_event,w
		jz	newcall

		movlw	MEVENT_UPDATE
		xorwf	MENU_event,w
		jz	update

		movlw	MEVENT_DOWN
		xorwf	MENU_event,w
		jz	ML_ci_menudown

		movlw	MEVENT_UP
		xorwf	MENU_event,w
		jz	ML_ci_menuup

		goto	ML_call_idle

;--------------------------------------------------------------------------
ML_ci_menudown	movlw	2		
		call	MENU_down
		goto	update

ML_ci_menuup	movlw	2
		call	MENU_up
		goto	update

;--------------------------------------------------------------------------
newcall		btfsc	MT8843_flag_outhook
		goto	newcall_out
		btfsc	MT8843_flag_incall
		goto	newcall_in
		goto	MENU


;--------------------------------------------------------------------------
update		btfsc	MT8843_flag_outhook
		goto	updcall_out
		btfsc	MT8843_flag_incall
		goto	updcall_in
		goto	MENU


;--------------------------------------------------------------------------
newcall_out	NLCD_SYMBOL NLCDS_OUT
updcall_out	MENU_PRINT "-IDO KI"
		NLCD_GOTOX 10
		movlw	MT8843_calltime_min
		call	MENU_print_time2
		goto	ML_call_idle

;--------------------------------------------------------------------------

newcall_in	NLCD_CLEAR
		NLCD_SYMBOL NLCDS_IN

updcall_in	testf	MENU_pos
		jnz	updcall_in_pt

		NLCD_GOTOX 0
		movlw	MT8843_buffer
		call	MENU_print_callno
		NLCD_CLEARREST
		goto	ML_call_idle

updcall_in_pt   MENU_PRINT "-IDO BE"
		NLCD_GOTOX 10
		movlw	MT8843_calltime_min
		call	MENU_print_time2
		NLCD_CLEARREST
		goto	ML_call_idle



;**************************************************************************
;***** menu null **********************************************************
;**************************************************************************

MENU		clrf	MENU_pos
		clrf	MENU_event

		goto	ML_main_print

ML_null_idle	call	MENU_IDLE
		movwf	MENU_event

		movlw	MEVENT_NEWCALL
		xorwf	MENU_event,w
		jz	newcall

		movlw	MEVENT_UPDATE
		xorwf	MENU_event,w
		jz	update

		movlw	MEVENT_OK
		xorwf	MENU_event,w
		jz	ML_main_handle

		goto	ML_null_idle
		


;**************************************************************************
;***** menu main **********************************************************
;**************************************************************************

ML_main_print	NLCD_SYMBOL NLCDS_NONE

		testf 	visit_counter
		jnz	ML_main_print1
		
		MENU_PRINT "     CID \xB106"	; print init string
		goto	ML_null_idle

ML_main_print1	MENU_PRINT "- UJ HIVAS"
		NLCD_GOTOX 16			; print visit counter
		movlw	visit_counter
		call	MENU_print_bcd
		goto	ML_null_idle

ML_main_handle  clrf	visit_counter
		MENU_BEGIN
		  MENU_SUB ML_list_print,  ML_list_handle
		  MENU_SUB ML_delete_print, ML_delete_handle
#ifndef MDEBUG
		  MENU_SUB ML_durout_print, ML_durout_handle
		  MENU_SUB ML_durin_print, ML_durin_handle
#endif ;MDEBUG
		MENU_END ML_main_idle, ML_main_print, newcall


;**************************************************************************
;***** menu list **********************************************************
;**************************************************************************

;			    123456789012345678
ML_list_print
		MENU_PRINT "- H. LISTA"
		NLCD_SYMBOL NLCDS_NONE
		NLCD_GOTOX 16

		movlw	CDB_hnofin
		movwf	FSR
		movf	INDF,w
		incf	FSR,f
		addwf	INDF,w
		movwf	MENU_listlen
		movwf	MENU_listitem
		BIN2BCD8I MENU_listlen
		movlw	AARGB1
		call	MENU_print_bcd
		goto	ML_main_idle

ML_list_handle	movlw	CDB_MODE_LAST
		call	CDB_read		; read last record
		goto	ML_list0_print
		
ML_list_idle	call	MENU_IDLE
		movwf	MENU_event

		movlw	MEVENT_OK		; select item
		xorwf	MENU_event,w
		jz	ML_list0_handle

		movlw	MEVENT_CANCEL		; up to parent
		xorwf	MENU_event,w
		jz	ML_main_handle

		movlw	MEVENT_DOWN		; prev number
		xorwf	MENU_event,w
		jz	ML_list_prev

		movlw	MEVENT_UP		; next number
		xorwf	MENU_event,w
		jz	ML_list_next

		movlw	MEVENT_NEWCALL		; newcall
		xorwf	MENU_event,w
		jz	newcall

		goto	ML_list_idle

;--------------------------------------------------------------------------
ML_list_next	movf	MENU_listitem,w
		xorwf	MENU_listlen,w
		jz	ML_list0_print
		incf	MENU_listitem,f

		movlw	CDB_MODE_NEXT
		call	CDB_read		; read prev. record
		goto	ML_list0_print


;--------------------------------------------------------------------------
ML_list_prev	decf	MENU_listitem,w
		jz	ML_list0_print
		movwf	MENU_listitem

		movlw	CDB_MODE_PREV
		call	CDB_read		; read next record
		goto	ML_list0_print


;**************************************************************************
;***** menu list0 * (selected item) ***************************************
;**************************************************************************

ML_list0_print  testf	MENU_listlen
		jnz	ML_list0_printnum

		MENU_PRINT "- A LISTA URES"
		NLCD_SYMBOL NLCDS_NONE
		MENU_WAIT
		goto	ML_list_print

ML_list0_printnum	
		NLCD_GOTOX 0
		BIN2BCD8I MENU_listitem
		movlw	AARGB1
		call	MENU_print_bcd
		movlw	' '
		NLCD_PRINTC
		movlw	CDB_record
		call	MENU_print_callno

		movlw	CDB_rduration
		movwf	FSR
		movf	INDF,w
		xorlw	CDB_STATE_LOST
		jz	ML_list0_lost

		NLCD_SYMBOL NLCDS_IN
		goto	ML_list_idle


ML_list0_lost	NLCD_SYMBOL NLCDS_PHONE
		goto	ML_list_idle


ML_list0_handle	MENU_BEGIN
		  MENU_SUB ML_datum_print,  ML_datum_handle
		  MENU_SUB ML_callno_print, ML_callno_handle	
		  MENU_SUB ML_delentry_print, ML_delentry_handle
		MENU_END ML_list0_idle, ML_list0_print, newcall



;**************************************************************************
;***** menu delete list ***************************************************
;**************************************************************************

;			    123456789012345678
ML_delete_print
		MENU_PRINT "- H. LISTA TORLESE"
		NLCD_SYMBOL NLCDS_NONE
		goto	ML_main_idle



ML_delete_handle
		MENU_PRINT "- BIZTOSAN TORLOD"

ML_delete_idle	call	MENU_IDLE
		movwf	MENU_event

		movlw	MEVENT_OK		; select item
		xorwf	MENU_event,w
		jz	ML_delete_doit

		movlw	MEVENT_CANCEL		; up to parent
		xorwf	MENU_event,w
		jz	ML_delete_print

		movlw	MEVENT_NEWCALL		; newcall
		xorwf	MENU_event,w
		jz	newcall

		goto	ML_delete_idle

;--------------------------------------------------------------------------
ML_delete_doit	MENU_PRINT "- TOROLVE"

		setc
		call	CDB_firstinit

		MENU_WAIT
		goto	ML_delete_print		



;**************************************************************************
;***** menu datum *********************************************************
;**************************************************************************
ML_datum_print	NLCD_GOTOX 0
		movlw	CDB_rdate
		call	MENU_print_time2

		NLCD_GOTOX 6
		movlw	CDB_rdate+2
		call	MENU_print_time2

		movlw	CDB_rduration
		movwf	FSR
		movf	INDF,w
		xorlw	CDB_STATE_LOST
		jz	ML_datum_pend

		NLCD_GOTOX 13
		movlw	CDB_rduration
		call	MENU_print_time2

ML_datum_pend
ML_datum_handle	goto	ML_list0_idle



;**************************************************************************
;***** menu callno ********************************************************
;**************************************************************************
ML_callno_print	NLCD_GOTOX 0
		movlw	CDB_record
		call	MENU_print_callno
ML_callno_handle
		goto	ML_list0_idle



;**************************************************************************
;***** menu delentry ******************************************************
;**************************************************************************
ML_delentry_print
		MENU_PRINT "- TORLES"
		goto	ML_list0_idle


ML_delentry_handle
		MENU_PRINT "- TOROLVE"
		
		movf	CDB_current,w
		call	CDB_delete

		MENU_WAIT

		decf	MENU_listlen,f
		jz	ML_list0_print		; empty list

		decf	MENU_listitem,f
		testf	MENU_listitem

		skipnz
		incf	MENU_listitem,f

		movlw	CDB_MODE_CURR
		call	CDB_read		; read current record
		goto	ML_list0_print



#ifndef	MDEBUG

;**************************************************************************
;***** menu durout ********************************************************
;**************************************************************************
ML_durout_print	MENU_PRINT "-IDO KI"

		NLCD_GOTOX 10
		movlw	CDB_hdur_out
		call	MENU_print_time3
		goto	ML_main_idle


ML_durout_handle
		MENU_PRINT "-IDO KI TORLESE"
ML_durout_idle
		call	MENU_IDLE
		movwf	MENU_event

		movlw	MEVENT_OK		; select item
		xorwf	MENU_event,w
		jz	ML_deldurout_doit

		movlw	MEVENT_CANCEL		; up to parent
		xorwf	MENU_event,w
		jz	ML_durout_print

		movlw	MEVENT_NEWCALL		; newcall
		xorwf	MENU_event,w
		jz	newcall
		goto	ML_durout_idle


ML_deldurout_doit
		MENU_PRINT "-IDO KI TOROLVE"

		movlw	CDB_hdur_out
		movwf	FSR
		clrf	INDF
		incf	FSR,f
		clrf	INDF
		incf	FSR,f
		clrf	INDF

		call	CDB_write_header

		MENU_WAIT
		goto	ML_durout_print	



;**************************************************************************
;***** menu durin *********************************************************
;**************************************************************************
ML_durin_print	MENU_PRINT "-IDO BE"

		NLCD_GOTOX 10
		movlw	CDB_hdur_in
		call	MENU_print_time3
		goto	ML_main_idle


ML_durin_handle
		MENU_PRINT "-IDO BE TORLESE"
ML_durin_idle
		call	MENU_IDLE
		movwf	MENU_event

		movlw	MEVENT_OK		; select item
		xorwf	MENU_event,w
		jz	ML_deldurin_doit

		movlw	MEVENT_CANCEL		; up to parent
		xorwf	MENU_event,w
		jz	ML_durin_print

		movlw	MEVENT_NEWCALL		; newcall
		xorwf	MENU_event,w
		jz	newcall
		goto	ML_durin_idle


ML_deldurin_doit
		MENU_PRINT "-IDO BE TOROLVE"

		movlw	CDB_hdur_in
		movwf	FSR
		clrf	INDF
		incf	FSR,f
		clrf	INDF
		incf	FSR,f
		clrf	INDF

		call	CDB_write_header

		MENU_WAIT
		goto	ML_durin_print	

#endif ;MDEBUG




;***** MENU_print_time ****************************************************
;* Print a time
;* Input : w <- address of time		;  (in BCD)
;* Output: 				;
;* Clock : 		
;**************************************************************************
MENU_print_time3
		call	MENU_print_bcd		; in duration hour
		movlw	'-'
		NLCD_PRINTC
		incf	FSR,w
MENU_print_time2
		call	MENU_print_bcd		; in duration min
		movlw	'-'
		NLCD_PRINTC
		incf	FSR,w
		call	MENU_print_bcd		; in duration sec
		NLCD_CLEARREST
		return



;***** MENU_print_bcd *****************************************************
;* Print a BCD number to LCD
;* Input : w <- address of BCD number	; 
;* Output: -				;
;* Clock : ?		
;**************************************************************************
MENU_print_bcd	movwf	FSR

		swapf	INDF,w
		andlw	0Fh
		iorlw	30h
		NLCD_PRINTC

		movf	INDF,w
		andlw	0Fh
		iorlw	30h
		NLCD_PRINTC

		return



;***** MENU_print *********************************************************
;* Print to LCD
;* Input : 				; 
;* Output: 				;
;* Clock : 		
;**************************************************************************
MENU_print	movwf	MENU_thigh
		NLCD_GOTOX 0

MENU_print1	call	MENU_print_getc
		testw
		jz	MENU_print_end	

		NLCD_PRINTC

		incf	MENU_tlow,f
		skipnz
		incf	MENU_thigh,f
		goto	MENU_print1


MENU_print_end	NLCD_CLEARREST
		return


MENU_print_getc	movf	MENU_thigh,w
		movwf	PCLATH
		movf	MENU_tlow,w
		movwf	PCL		; computed goto!




;***** MENU_down **********************************************************
;* down to next menu item
;* Input : W <- number of menuitems	; 
;* Output: 				;
;* Clock : 6		
;**************************************************************************
MENU_down	incf	MENU_pos,f
		xorwf	MENU_pos,w
		skipnz
		clrf	MENU_pos
		return



;***** MENU_up ************************************************************
;* up to previous menu item
;* Input : W <- number of menuitems	; 
;* Output: 				;
;* Clock : 6		
;**************************************************************************
MENU_up		testf	MENU_pos
		skipnz
		movwf	MENU_pos
		decf	MENU_pos,f
		return		



;***** MENU_print_callno **************************************************
;* print calling number
;* Input : W <- address of record  	; 
;* Output: -				;
;* Clock : ?	
;**************************************************************************
MENU_print_callno
		addlw	CDB_INUMBER
		movwf	FSR

		swapf	INDF,w
		andlw	0Fh
		jz	MENU_nocid

		movwf	MENU_templen
		
;----- print 1st and n+1. number ------------------------------------------
MENU_pcid_next1	movf	INDF,w
		andlw	0Fh
		iorlw	30h
		NLCD_PRINTC
		decf	MENU_templen,f
		jz	MENU_pcid_end
		
;----- print n. number ----------------------------------------------------
		incf	FSR,f
		swapf	INDF,w
		andlw	0Fh
		iorlw	30h
		NLCD_PRINTC
		decf	MENU_templen,f
		jnz	MENU_pcid_next1
		
MENU_pcid_end	NLCD_CLEARREST
		return


;--------------------------------------------------------------------------
MENU_nocid	movlw	'-'
		NLCD_PRINTC
		movlw	'-'
		NLCD_PRINTC
		movlw	'-'
		NLCD_PRINTC
		goto MENU_pcid_end



;***** MENU_wait **********************************************************
;* Wait 1 Seconds (menu delay)
;* Input : -			  	; 
;* Output: -				;
;* Clock : 1 sec
;**************************************************************************
MENU_wait	TIMER_WAIT	MENU_delay, 1000	; 1 Second
		return



;**************************************************************************

